var doc = app.activeDocument;
var sel = doc.selection;
var layers = []
var collection = [];
var path_ = [];
var outputLayer = doc.layers.add();
var STROKE_WIDTH = .01
var STROKE_COLOR = new RGBColor();

var a;
var b;

var cx;
var cy;

var r0;
var r1;

var ratio = 10;
var angle = 360;

function showDialog() {
    myDlg = new Window('dialog');

    myDlg.add('statictext', undefined, "ratio (recommended: 10..1000)");
    ratioTxt = myDlg.add('edittext', [0, 0, 100, 20], "100", {
        helpTip: "Enter the size (in points) here"
    });
        myDlg.add('statictext', undefined, "angle (recommended: 180..360)");

    angleTxt = myDlg.add('edittext', [0, 0, 100, 20], "360", {
        helpTip: "Enter the size (in points) here"
    });
    
    myDlg.add('button', undefined, "OK", {
        helpTip: "Click to insert text into document"
    });
    myDlg.add('button', undefined, "Cancel", {
        helpTip: "Click to close this dialog"
    });
    
    return myDlg.show()

}

function collectObjects(o) {
    a = selection[0];
    b = selection[1];

    r0 = (a.geometricBounds[2] - a.geometricBounds[0]) / 2;
    r1 = (b.geometricBounds[2] - b.geometricBounds[0]) / 2;

    cx = a.geometricBounds[0] + r0;
    cy = a.geometricBounds[1] - r0;


    $.writeln(r0, r1);

}

function createPath() {
    var myLine = outputLayer.pathItems.add();
    myLine.stroked = true;
    myLine.filled = false;

    myLine.strokeWidth = STROKE_WIDTH;
    //myLine.strokeColor = doc.swatches[color].color
    myLine.strokeColor = STROKE_COLOR;
    myLine.strokeCap = StrokeCap.ROUNDENDCAP
    myLine.strokeJoin = StrokeJoin.ROUNDENDJOIN
    myLine.setEntirePath(path_);


}

function process() {
    var x, y, theta;
    var step = 1 / ratio / 100
    var ang=angle/360
    for (theta = 0; theta <= Math.PI * 2*ang; theta += step) {
        x = cx + r0 * Math.cos(theta) + r1 * Math.cos(theta * ratio);
        // $.writeln(cx,r0,Math.cos(theta),r1,Math.cos(theta * ratio));    
        y = cy + r0 * Math.sin(theta) + r1 * Math.sin(theta * ratio);
        path_.push([x, y]);
        //no moe than 1k objects in path
        if (path_.length >= 1000) {
            createPath();
            //add last elemnt into new path
            path_ = [path_[path_.length - 1]];
        }

    }
}


function main() {

    if ((sel.length != 2)) {
        alert("draw and select 2 circles")
        return;
    }
    if(showDialog()!=1)return
    ratio = Number(ratioTxt.text);
    angle = Number(angleTxt.text);

    collectObjects()
    process()
    createPath();

}

main();